---
machine_translated: true
machine_translated_rev: 72537a2d527c63c07aa5d2361a8829f3895cf2bd
toc_priority: 35
toc_title: "\u062D\u0633\u0627\u0628"
---

# توابع ریاضی {#arithmetic-functions}

برای تمام توابع ریاضی, نوع نتیجه به عنوان کوچکترین نوع شماره که در نتیجه متناسب با محاسبه, اگر چنین نوع وجود دارد. حداقل به طور همزمان بر اساس تعداد بیت ها امضا شده است یا شناور است. اگر بیت به اندازه کافی وجود ندارد, بالاترین نوع بیت گرفته شده است.

مثال:

``` sql
SELECT toTypeName(0), toTypeName(0 + 0), toTypeName(0 + 0 + 0), toTypeName(0 + 0 + 0 + 0)
```

``` text
┌─toTypeName(0)─┬─toTypeName(plus(0, 0))─┬─toTypeName(plus(plus(0, 0), 0))─┬─toTypeName(plus(plus(plus(0, 0), 0), 0))─┐
│ UInt8         │ UInt16                 │ UInt32                          │ UInt64                                   │
└───────────────┴────────────────────────┴─────────────────────────────────┴──────────────────────────────────────────┘
```

حساب توابع کار برای هر جفت از انواع از UInt8, UInt16, UInt32, UInt64, Int8, Int16, Int32, Int64, Float32 یا Float64.

سرریز به همان شیوه که در ج تولید++.

## به علاوه (یک, ب), + اپراتور ب {#plusa-b-a-b-operator}

محاسبه مجموع اعداد.
شما همچنین می توانید اعداد صحیح را با یک تاریخ یا تاریخ و زمان اضافه کنید. در مورد یک تاریخ, اضافه کردن یک عدد صحیح به معنی اضافه کردن تعداد مربوط به روز. برای تاریخ با زمان, به این معنی اضافه کردن شماره مربوطه را از ثانیه.

## منفی (یک, ب), اپراتور الف ب {#minusa-b-a-b-operator}

محاسبه تفاوت. نتیجه همیشه امضا شده است.

You can also calculate integer numbers from a date or date with time. The idea is the same – see above for ‘plus’.

## ضرب (ب) اپراتور \* ب {#multiplya-b-a-b-operator}

محاسبه محصول از اعداد.

## تقسیم کردن (یک, ب), یک / اپراتور ب {#dividea-b-a-b-operator}

محاسبه خارج قسمت از اعداد. نوع نتیجه همیشه یک نوع شناور است.
این تقسیم عدد صحیح نیست. برای تقسیم عدد صحیح, استفاده از ‘intDiv’ تابع.
هنگامی که تقسیم بر صفر می کنید ‘inf’, ‘-inf’ یا ‘nan’.

## اینترنت) {#intdiva-b}

محاسبه خارج قسمت از اعداد. تقسیم به اعداد صحیح, گرد کردن پایین (با ارزش مطلق).
یک استثنا در هنگام تقسیم بر صفر یا زمانی که تقسیم یک عدد منفی حداقل توسط منهای یک پرتاب می شود.

## intDivOrZero(a, b) {#intdivorzeroa-b}

متفاوت از ‘intDiv’ در این بازده صفر در هنگام تقسیم صفر و یا زمانی که تقسیم یک عدد منفی حداقل منهای یک.

## مودولو (و, ب), یک % اپراتور ب {#moduloa-b-a-b-operator}

محاسبه باقی مانده پس از تقسیم.
اگر استدلال اعداد ممیز شناور هستند قبل از تبدیل به اعداد صحیح با حذف بخش اعشاری هستند.
باقی مانده است به همان معنا که در ج گرفته++. تقسیم کوتاه برای اعداد منفی استفاده می شود.
یک استثنا در هنگام تقسیم بر صفر یا زمانی که تقسیم یک عدد منفی حداقل توسط منهای یک پرتاب می شود.

## moduloOrZero(a, b) {#moduloorzeroa-b}

متفاوت از ‘modulo’ در که باز می گردد صفر زمانی که مقسوم علیه صفر است.

## نفی (),- اپراتور {#negatea-a-operator}

محاسبه یک عدد با علامت معکوس. نتیجه همیشه امضا شده است.

## شکم(یک) {#arithm_func-abs}

محاسبه ارزش مطلق تعداد (). به این معنا که, اگر یک \< 0, باز می گردد یک. برای انواع عدد صحیح امضا, این برمی گرداند یک عدد بدون علامت.

## گسیدی(یک, ب) {#gcda-b}

بازگرداندن بزرگترین مقسوم علیه مشترک از اعداد.
یک استثنا در هنگام تقسیم بر صفر یا زمانی که تقسیم یک عدد منفی حداقل توسط منهای یک پرتاب می شود.

## اندازه) {#lcma-b}

بازگرداندن چند حداقل مشترک از اعداد.
یک استثنا در هنگام تقسیم بر صفر یا زمانی که تقسیم یک عدد منفی حداقل توسط منهای یک پرتاب می شود.

[مقاله اصلی](https://clickhouse.tech/docs/en/query_language/functions/arithmetic_functions/) <!--hide-->
