---
machine_translated: true
machine_translated_rev: 72537a2d527c63c07aa5d2361a8829f3895cf2bd
---

# از بند {#select-from}

این `FROM` بند منبع برای خواندن داده ها از مشخص:

-   [جدول](../../../engines/table-engines/index.md)
-   [خرده فروشی](index.md) لینک بهتر ##}
-   [تابع جدول](../../table-functions/index.md#table-functions)

[JOIN](join.md) و [ARRAY JOIN](array-join.md) بند نیز ممکن است مورد استفاده قرار گیرد به گسترش قابلیت های `FROM` بند بند.

خرده فروشی دیگر است `SELECT` پرسوجوی که ممکن است در داخل پرانتز مشخص شود `FROM` بند بند.

`FROM` بند می تواند شامل منابع داده های متعدد, جدا شده توسط کاما, که معادل انجام است [CROSS JOIN](join.md) با اونا.

## تغییردهنده نهایی {#select-from-final}

چه زمانی `FINAL` مشخص شده است, تاتر به طور کامل ادغام داده ها قبل از بازگشت به نتیجه و در نتیجه انجام تمام تحولات داده که در طول ادغام برای موتور جدول داده شده اتفاق می افتد.

این قابل اجرا است در هنگام انتخاب داده ها از جداول که با استفاده از [ادغام](../../../engines/table-engines/mergetree-family/mergetree.md)- خانواده موتور (به جز `GraphiteMergeTree`). همچنین برای پشتیبانی:

-   [تکرار](../../../engines/table-engines/mergetree-family/replication.md) نسخه های `MergeTree` موتورها.
-   [نما](../../../engines/table-engines/special/view.md), [بافر](../../../engines/table-engines/special/buffer.md), [توزیع شده](../../../engines/table-engines/special/distributed.md) و [ماده بینی](../../../engines/table-engines/special/materializedview.md) موتورها که بیش از موتورهای دیگر کار می کنند به شرطی که بیش از ایجاد شده اند `MergeTree`- جدول موتور .

### اشکالاتی {#drawbacks}

نمایش داده شد که با استفاده از `FINAL` اعدام به همان سرعتی که نمایش داده شد مشابه که نمی, زیرا:

-   پرس و جو در یک موضوع اجرا و داده ها در طول اجرای پرس و جو با هم ادغام شدند.
-   نمایش داده شد با `FINAL` خوانده شده ستون کلید اولیه در علاوه بر این به ستون مشخص شده در پرس و جو.

**در بیشتر موارد, اجتناب از استفاده از `FINAL`.** روش معمول این است که از نمایش های مختلف استفاده کنید که فرایندهای پس زمینه را فرض می کنند `MergeTree` موتور هنوز اتفاق نیفتاده است و با استفاده از تجمع (به عنوان مثال برای دور انداختن تکراری) مقابله می کند. پردازشگر پشتیبانی شده: ##}

## پیاده سازی اطلاعات {#implementation-details}

اگر `FROM` بند حذف شده است, داده خواهد شد از خواندن `system.one` جدول
این `system.one` جدول شامل دقیقا یک ردیف است (این جدول همان هدف را به عنوان جدول دوگانه موجود در سایر دساماسها انجام می دهد).

برای اجرای پرس و جو تمام ستون های ذکر شده در پرس و جو از جدول مناسب استخراج می شوند. هر ستون برای پرس و جو خارجی مورد نیاز نیست از کارخانه های فرعی پرتاب می شود.
اگر پرس و جو هیچ ستون لیست نیست (به عنوان مثال, `SELECT count() FROM t`), برخی از ستون از جدول استخراج به هر حال (کوچکترین ترجیح داده می شود), به منظور محاسبه تعداد ردیف.
