# Математические функции {#matematicheskie-funktsii}

Все функции возвращают число типа Float64. Точность результата близка к максимально возможной, но результат может не совпадать с наиболее близким к соответствующему вещественному числу машинно представимым числом.

## e() {#e}

Возвращает число типа Float64, близкое к числу e.

## pi() {#pi}

Возвращает число типа Float64, близкое к числу π.

## exp(x) {#expx}

Принимает числовой аргумент, возвращает число типа Float64, близкое к экспоненте от аргумента.

## log(x) {#logx}

Принимает числовой аргумент, возвращает число типа Float64, близкое к натуральному логарифму от аргумента.

## exp2(x) {#exp2x}

Принимает числовой аргумент, возвращает число типа Float64, близкое к 2 в степени x.

## log2(x) {#log2x}

Принимает числовой аргумент, возвращает число типа Float64, близкое к двоичному логарифму от аргумента.

## exp10(x) {#exp10x}

Принимает числовой аргумент, возвращает число типа Float64, близкое к 10 в степени x.

## log10(x) {#log10x}

Принимает числовой аргумент, возвращает число типа Float64, близкое к десятичному логарифму от аргумента.

## sqrt(x) {#sqrtx}

Принимает числовой аргумент, возвращает число типа Float64, близкое к квадратному корню от аргумента.

## cbrt(x) {#cbrtx}

Принимает числовой аргумент, возвращает число типа Float64, близкое к кубическому корню от аргумента.

## erf(x) {#erfx}

Если x неотрицательно, то erf(x / σ√2) - вероятность того, что случайная величина, имеющая нормальное распределение со среднеквадратичным отклонением σ, принимает значение, отстоящее от мат. ожидания больше чем на x.

Пример (правило трёх сигм):

``` sql
SELECT erf(3 / sqrt(2))
```

``` text
┌─erf(divide(3, sqrt(2)))─┐
│      0.9973002039367398 │
└─────────────────────────┘
```

## erfc(x) {#erfcx}

Принимает числовой аргумент, возвращает число типа Float64, близкое к 1 - erf(x), но без потери точности для больших x.

## lgamma(x) {#lgammax}

Логарифм от гамма функции.

## tgamma(x) {#tgammax}

Гамма функция.

## sin(x) {#sinx}

Синус.

## cos(x) {#cosx}

Косинус.

## tan(x) {#tanx}

Тангенс.

## asin(x) {#asinx}

Арксинус.

## acos(x) {#acosx}

Арккосинус.

## atan(x) {#atanx}

Арктангенс.

## pow(x, y) {#powx-y}

Принимает два числовых аргумента x и y. Возвращает число типа Float64, близкое к x в степени y.

[Оригинальная статья](https://clickhouse.tech/docs/ru/query_language/functions/math_functions/) <!--hide-->
